unit KDSSV;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, KDSContainerUnit1, DBXJSON, Generics.Collections, DB, ActnList,
  PlatformDefaultStyleActnCtrls, ActnMan, CategoryButtons, ExtCtrls, DBClient,
  JFXMLParse, Grids, Wwdbigrd, Wwdbgrid, POSDBGrid, StdCtrls, ATFileNotification ;

type
  TKDSSVForm = class(TForm)
    TA: TClientDataSet;
    TAs: TDataSource;
    TBs: TDataSource;
    CategoryPanelGroup1: TCategoryPanelGroup;
    CategoryPanel1: TCategoryPanel;
    CategoryPanel2: TCategoryPanel;
    cb1: TCategoryButtons;
    ActionManager: TActionManager;
    Action1: TAction;
    Action2: TAction;
    Action3: TAction;
    TATA001: TStringField;
    TATA002: TStringField;
    TATA003: TStringField;
    TATA006: TStringField;
    TATableNo: TStringField;
    TADeliveryType: TStringField;
    TB: TClientDataSet;
    TBTB001: TStringField;
    TBTB002: TStringField;
    TBTB003: TStringField;
    TBTB006: TStringField;
    TBPluName: TStringField;
    TBSaleQty: TFloatField;
    TBDoItemOK: TStringField;
    gridTA: TPOSDBGrid;
    gridTB: TPOSDBGrid;
    TBDishWindow: TStringField;
    CategoryPanel3: TCategoryPanel;
    ListBox1: TListBox;
    Action4: TAction;
    Action5: TAction;
    Button1: TButton;
    Notification: TATFileNotification;
    TBTB007: TStringField;
    { TODO : qs }
    procedure Action2Execute(Sender: TObject);
    procedure Action1Execute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Action3Execute(Sender: TObject);
    procedure Action4Execute(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure NotificationChanged(Sender: TObject);
    procedure TBReconcileError(DataSet: TCustomClientDataSet;
      E: EReconcileError; UpdateKind: TUpdateKind;
      var Action: TReconcileAction);
    procedure TAReconcileError(DataSet: TCustomClientDataSet;
      E: EReconcileError; UpdateKind: TUpdateKind;
      var Action: TReconcileAction);
    procedure TBDeleteError(DataSet: TDataSet; E: EDatabaseError;
      var Action: TDataAction);
    procedure TADeleteError(DataSet: TDataSet; E: EDatabaseError;
      var Action: TDataAction);
    procedure TBBeforeDelete(DataSet: TDataSet);
    procedure TABeforeDelete(DataSet: TDataSet);
    procedure TABeforeGetRecords(Sender: TObject; var OwnerData: OleVariant);
    procedure TAAfterGetRecords(Sender: TObject; var OwnerData: OleVariant);
    procedure TAAfterDelete(DataSet: TDataSet);
    procedure TABeforeApplyUpdates(Sender: TObject; var OwnerData: OleVariant);
  private
    procedure NotifyFile(AFileName : String);
    { Private declarations }
  public
    procedure DOLOG(xstr:string);
    { Public declarations }
  end;

var
  KDSSVForm: TKDSSVForm;

const
  KDSChannel = 'KDSChannel';

implementation

{$R *.dfm}

uses KDSServerContainerUnit;

procedure TKDSSVForm.Action1Execute(Sender: TObject);
VAR
  mSR  : TSearchRec;
  xXmlNode:TJFXmlParse;
  mFileName : Array[0..MAX_PATH] OF WideChar;
  mdirPath, mFilePath, mFileNames:string;
  mList:TstringList;
  mTA001,  mTA002,  mTA003,  mTA006 : String;
  mInt, FCount, i:integer;

  function GetNodeValue(xStr:String):String;
  begin
    if xXmlNode.IsExistNode(xStr) then
    begin
      if (xXmlNode.MoveTo(xStr, false)) then
        Result := xXmlNode.Value;
      xXmlNode.MoveUp ;
    end;
  end;

begin
  { TODO : }leǳưʧ@ }
  mList := TStringList.Create;

  { TODO : o| ]OIIS ΧOبk }
  GetModuleFileName(HInstance, @mFileName, MAX_PATH);
  mdirPath := IncludeTrailingBackslash(ExtractFilePath(mFileName));

  mInt := FindFirst(mdirPath+'KDS\Before\*.xml', faAnyFile, mSR);
  try
    while mInt = 0 do
    begin
      mFilePath := mdirPath + 'KDS\Before\' + mSR.Name;
      //᭱hƻݭn
      mFileNames := mSR.Name;

      { TODO : }l }
      try
        xXmlNode := TJFXmlParse.Create;
        xXmlNode := xXmlNode.LoadXMLFromFile(mFilePath);

        { TODO 1 -o01753 : BzTA }
        if xXmlNode.MoveTo('Order', false) then
        begin
          Ta.Append;
          if xXmlNode.MoveTo('header', false) then
          begin
            mTA001 := GetNodeValue('TA001');
            mTA002 := GetNodeValue('TA002');
            mTA003 := GetNodeValue('TA003');
            mTA006 := GetNodeValue('TxNo');

            Ta.FieldbyName('TA001').AsString := mTA001;
            Ta.FieldbyName('TA002').AsString := mTA002;
            Ta.FieldbyName('TA003').AsString := mTA003;
            Ta.FieldbyName('TableNo').AsString := GetNodeValue('TableNo');
            Ta.FieldbyName('TA006').AsString := mTA006;
            Ta.FieldbyName('DeliveryType').AsString := GetNodeValue('DeliveryType');
            xXmlNode.Moveup;
          end;
        end;

        { TODO 2 -o01753 : BzTB }

        if xXmlNode.MoveTo('Detail', false) then
        begin
          xXmlNode.GetNodeList(mList);
          FCount := mList.Count;
          for i := 1 to FCount  do
          begin
            TB.Append;
            if xXmlNode.MoveTo('item', false) then
            begin
              TB.FieldbyName('TB001').AsString := mTA001;
              TB.FieldbyName('TB002').AsString := mTA002;
              TB.FieldbyName('TB003').AsString := mTA003;
              TB.FieldbyName('TB006').AsString := mTA006;
              TB.FieldbyName('TB007').AsString := inttostr(i);
              TB.FieldbyName('PluName').AsString := GetNodeValue('PluName');
              TB.FieldbyName('SaleQty').AsString := GetNodeValue('SaleQty');
              TB.FieldbyName('DoItemOK').AsString := GetNodeValue('DoItemOK');
              TB.FieldbyName('DishWindow').AsString := GetNodeValue('DishWindow');
            end;
            TB.Post;
            TB.First;
            xXmlNode.MoveSibling;
          end;
        end;
        Ta.Post;
        TA.First;
        TB.MasterFields := 'TA001;TA002;TA003;TA006';
        TB.IndexFieldNames := 'TB001;TB002;TB003;TB006';
        TB.MasterSource:=TAs;

        { TODO : xs\ ha }
        MoveFile(PChar(mFilePath), PChar(mdirPath+'\KDS\AFTER\'+mFileNames));

        { TODO : U@ɮ }
        mInt := FindNext(mSR);
      except
      end;
    end;
  finally
    Action2Execute(self);
    FindClose(mSR);
    mList.Free;
    xXmlNode.Free;
  end;
end;

procedure TKDSSVForm.Action2Execute(Sender: TObject);
var
  vMessage : TJSONObject;
  x:string;
begin
  vMessage := TJSONObject.Create;
  vMessage.AddPair(TJSONString.Create('reset'), TJSONString.Create('NewTB'));
  vMessage.AddPair(TJSONString.Create('NewTB'), TJSONString.Create('NewTB'));

  { TODO : DEBUG }
  x := vMessage.Get('reset').JsonValue.value;
  try
    ServerContainer1.DSServer1.BroadcastMessage(KDSChannel, vMessage);
  finally
//    vMessage.Free;
  end;
end;

procedure TKDSSVForm.Action3Execute(Sender: TObject);
var
  aIdList : TList<String>;
  sId : String;
begin
  aIdList := ServerContainer1.DSServer1.GetAllChannelCallbackId(KDSChannel);
  try
    for sId in aIdList do
      ListBox1.Items.Add(sId);
  finally
    aIdList.Free;
  end;
end;

procedure TKDSSVForm.Action4Execute(Sender: TObject);
var
  vMessage : TJSONObject;
  x:string;
begin
  vMessage := TJSONObject.Create;
  vMessage.AddPair(TJSONString.Create('reset'), TJSONString.Create('EndNotice'));

  { TODO : DEBUG }
  x := vMessage.Get('reset').JsonValue.value;
  try
    ServerContainer1.DSServer1.BroadcastMessage(KDSChannel, vMessage);
  finally
  end;
end;

procedure TKDSSVForm.Button1Click(Sender: TObject);
VAR
I :INTEGER;
begin
  listbox1.Clear;


  TA.first;
  while not TA.eof do
  begin
    for I:=0 TO  TB.RecordCount -1 do
      TB.Delete;
    TA.Delete;
  end;
end;

procedure TKDSSVForm.DOLOG(xstr: string);
begin
  ListBox1.Items.Add(xstr);
  ListBox1.Selected[listbox1.Count-1];

end;

procedure TKDSSVForm.FormCreate(Sender: TObject);
var
  mPath:string;
begin
  TA.CreateDataSet;
  TB.CreateDataSet;
  mPath := ExtractFilePath(Application.EXEName);
  NotifyFile(mPath+'KDS\Before');
//C:\inetpub\CMPOS\Dlls\KDS
end;

procedure TKDSSVForm.NotificationChanged(Sender: TObject);
begin
  Action1Execute(self);
end;

procedure TKDSSVForm.NotifyFile(AFileName: String);
begin
  with Notification do
  begin
    Stop;
    Directory:= AFileName;
    Options:= [];
    { TODO : ڥus }
    Options:= Options + [foNotifyLastWrite];
    Start;
  end;;
end;

procedure TKDSSVForm.TAAfterDelete(DataSet: TDataSet);
begin
  KDSSVForm.DOLOG('AfterDelete');
  KDSSVForm.Action4Execute(self);
end;

procedure TKDSSVForm.TAAfterGetRecords(Sender: TObject;
  var OwnerData: OleVariant);
begin
  DOLOG('BeforeGetRecords:  ի'  )  ;
end;

procedure TKDSSVForm.TABeforeApplyUpdates(Sender: TObject;
  var OwnerData: OleVariant);
begin
  TA.Refresh;
end;

procedure TKDSSVForm.TABeforeDelete(DataSet: TDataSet);
begin
  ListBox1.Items.Add('TA Save' );
end;

procedure TKDSSVForm.TABeforeGetRecords(Sender: TObject;
  var OwnerData: OleVariant);
begin
  DOLOG('BeforeGetRecords:  իe'  )  ;
end;

procedure TKDSSVForm.TADeleteError(DataSet: TDataSet; E: EDatabaseError;
  var Action: TDataAction);
begin
  ListBox1.Items.Add('TA: Delete '+  E.Message );
end;

procedure TKDSSVForm.TAReconcileError(DataSet: TCustomClientDataSet;
  E: EReconcileError; UpdateKind: TUpdateKind; var Action: TReconcileAction);
begin
  ListBox1.Items.Add('TA: Reconcile '+  E.Message );
end;

procedure TKDSSVForm.TBBeforeDelete(DataSet: TDataSet);
begin
  ListBox1.Items.Add('TB SAVE' );
end;

procedure TKDSSVForm.TBDeleteError(DataSet: TDataSet; E: EDatabaseError;
  var Action: TDataAction);
begin
  ListBox1.Items.Add('TB: Delete '+  E.Message );
end;

procedure TKDSSVForm.TBReconcileError(DataSet: TCustomClientDataSet;
  E: EReconcileError; UpdateKind: TUpdateKind; var Action: TReconcileAction);
begin
  ListBox1.Items.Add('TB: Reconcile '+  E.Message );
end;

end.

